* "Test Effective Addressing Modes"

	org 	$400400


* Immediate (source only)
	move.b	#$12,d0		;do=$12	
	move.w	#$1245,d1	;d1=$1245
	move.l	#$123467,d2	;d2=$123467
* >>>negative value
	move.b	#$80,d3		;d3=$80
	move.w	#$8765,d4	;d4=$8765
	move.l	#$ffff9876,d5	;d5=$ffff9876


* Data Register Direct
	move.b	d0,d6		;d6=$12
	move.w	d1,d6		;d6=$1245
	move.l	d2,d6		;d6=$123467
* >>>negative value
	move.b	d3,d0		;d0=$80
	move.w	d4,d0		;d0=$8796
	move.l	d5,d0		;d0=$ffff9876


* Address Register Direct (size = word/long)
	movea.w	#$400,a0	;a0=$400
	movea.l	#$400400,a1	;a1=$400400
	move.w	#$8000,a2	;a2=$8000
	move.w	a0,a1		;a1=$400
	move.l	d2,a3		;a3=$123467


* Absolute Short
	move.b	#$45,$400	;$400 = #$45
	move.b	$400,d0		;d0=$45 
* >>>$ff8000 - $ffffff
	move.l	#$12345,$8000	;$8000 = #$00012345
	move.w	$8000,d1	;d1=$1
	

* Absolute Long (max $ffffff)
	move.b	#$45,$40000	;$40000 = #$45
	move.w	$40000,d0	;d0=$4500
	move.l	#$12345,$400400	;$400400 = #$00012345
	move.w	$400400,d1	;d1=$1


	move.l	#0,d0
	move.l	#0,d1
	move.l	#0,d2
* Address Register Indirect	
	move.w	#$400,a0	;a0=$400
	move.b	#$89,(a0)	;$400 = #$89
	move.w	(a0),d0		;d0=$8900
	move.l	#$400400,a1	;a1=$400400
	move.w	#$1234,d1	;d1=$1234
	move.l	d1,(a1)		;$400400 = #$00001234
	move.w	$400400,d2	;d2=$0	
	

****************************************************************************
* Below ea mode not tested yet
* increment/decrement value according size of operation
*	byte = 1, word = 2, long = 4
* Address Register Indirect with Post-Increment
	move.w	#$400,a0
	move.b	#$89,(a0)+	;expected a0=401
	move.b	(a0),d1		;expected exception occur. 'Address error'. 
	move.b	#$10,(a0)+	;expected a0=402
	move.l	$400,d5		;expected d5=8910
	move.l	#$400400,a1
	move.w	#$1234,d1
	move.w	d1,(a1)+	;expected a1=400402
	move.l	#$12345678,(a1)+ ;expected a1=400406
	move.l	$400400,d2	;expected d2=12123456
	move.l	#$400402,a2
	move.w	(a2)+,d1	;expected a2=400404


* Address Register Indirect with Pre-Decrement
	move.w	#$406,a0
	move.b	#$89,-(a0)	;expected a0=405
	move.b	(a0),d1		;expected exception occur. 'Address error'. 
	move.b	#$10,-(a0)	;expected a0=404
	move.l	$402,d5		;expected d5=1089
	move.l	#$400406,a1
	move.w	#$1234,d1
	move.w	d1,-(a1)	;expected a1=400404
	move.l	#$12345678,-(a1) ;expected a1=400400
	move.l	$400400,d2	;expected d2=12123456
	move.l	#$400408,a2
	move.w	-(a2),d1	;expected a2=400406



* Address Register Indirect with Displacement (displacement = 16-bit)
	move.w	#$406,a0
	move.b	#$89,2(a0)	;expected a0=406
	move.w	2(a0),d1	;expected d1=8900
	move.b	#$10,-4(a0)	;expected a0=406
	move.l	$400,d5		;expected d5=100000
	move.l	#$400406,a1
	move.w	#$1234,d1
	move.w	d1,6(a1)	;expected a1=400406
	move.l	#$12345678,-2(a1) ;expected a1=400406
	move.l	$400408,d2	;expected d2=34000000
	move.w	#$5678,$400404
	move.l	#$400408,a2
	move.w	-2(a2),d1	;expected d1=7800

* Address Register Indirect with Index
	move.b	-89(a1,d0.w),d3
	move.w	3(a2,d1.w),d7
	move.l	23(a5,d6.l),d2
	move.b	-8(a7,d3.l),d1
	move.l	$7f(a0,d4.w),d0




* Program Counter with Displacement

* Program Counter with Index



	end