@echo off

IF NOT EXIST 68000editor.jar GOTO EditorError

IF ."%JAVA_HOME%"==. GOTO JdkError

set JAVACMD=%JAVA_HOME%\bin\java.exe

IF NOT EXIST "%JAVACMD%" goto JdkError

:OK
title Console for the 68000 Editor
color f9
ECHO Open the 68000 Editor
java -jar 68000editor.jar
cls
ECHO Thank you for using the 68000 Editor
ECHO .
ECHO .
ECHO Send comments and bug reports to helmi03@yahoo.com
pause
GOTO End

:EditorError
ECHO ERROR!
ECHO Could not find 68000editor.jar
ECHO Make sure the editor in the same directory
pause
GOTO End

:JdkError
ECHO Could not find a JDK.
ECHO Either you have to install JDK 1.4 (or up),
ECHO or you have to set JAVA_HOME to your JDK installation directory.
ECHO .
ECHO You can go to 68000 Simulator installation directory, then
ECHO add a line below in the 68000 Editor.bat at first line
ECHO "set JAVA_HOME=<java_install_dir>"
ECHO for example, set JAVA_HOME=C:\Program Files\Java\j2re1.4.2
pause

:End





